"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = deleteDbEntry;
const DB_HANDLER_1 = __importDefault(require("../../../utils/backend/global-db/DB_HANDLER"));
const DSQL_USER_DB_HANDLER_1 = __importDefault(require("../../../utils/backend/global-db/DSQL_USER_DB_HANDLER"));
const LOCAL_DB_HANDLER_1 = __importDefault(require("../../../utils/backend/global-db/LOCAL_DB_HANDLER"));
/**
 * # Delete DB Entry Function
 * @description
 */
function deleteDbEntry(_a) {
    return __awaiter(this, arguments, void 0, function* ({ dbContext, paradigm, dbFullName, tableName, identifierColumnName, identifierValue, }) {
        try {
            const isMaster = global.DSQL_USE_LOCAL
                ? true
                : (dbContext === null || dbContext === void 0 ? void 0 : dbContext.match(/dsql.user/i))
                    ? false
                    : dbFullName && !dbFullName.match(/^datasquirel$/)
                        ? false
                        : true;
            const dbHandler = global.DSQL_USE_LOCAL
                ? LOCAL_DB_HANDLER_1.default
                : isMaster
                    ? DB_HANDLER_1.default
                    : DSQL_USER_DB_HANDLER_1.default;
            /**
             * Execution
             *
             * @description
             */
            const query = `DELETE FROM \`${dbFullName}\`.\`${tableName}\` WHERE \`${identifierColumnName}\`=?`;
            const deletedEntry = isMaster
                ? yield dbHandler(query, [identifierValue])
                : yield dbHandler({
                    paradigm,
                    queryString: query,
                    queryValues: [identifierValue],
                });
            /**
             * Return statement
             */
            return deletedEntry;
        }
        catch (error) {
            return null;
        }
    });
}
