import { GetReturn, ServerQueryParam } from "../../package-shared/types";
export type ApiGetQueryObject<T extends {
    [k: string]: any;
} = {
    [k: string]: any;
}> = {
    query: ServerQueryParam<T>;
    table: string;
    dbFullName?: string;
};
type Param<T extends {
    [k: string]: any;
} = {
    [k: string]: any;
}> = {
    key?: string;
    db?: string;
    query: string | ApiGetQueryObject<T>;
    queryValues?: string[];
    tableName?: string;
    user_id?: string | number;
    debug?: boolean;
};
export type ApiGetParams = Param;
/**
 * # Make a get request to Datasquirel API
 */
export default function get<T extends {
    [k: string]: any;
} = {
    [k: string]: any;
}>({ key, db, query, queryValues, tableName, user_id, debug, }: Param<T>): Promise<GetReturn>;
export {};
